<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: Feed forward neural network</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('ffnet.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">Feed forward neural network</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="ffnet-training"></a>
Training</h1>
<p>MeLOn supports two options for training feed forward neural networks:</p><ul>
<li>Using python with the keras interface for training neural networks with tensorflow</li>
<li>Using Matlab and its included Machine Learning Toolbox</li>
</ul>
<p>It is recommended that you rely on the provided example scripts for training your model. The reason for this is that MeLOn doesn't support all function included in keras or the Matlab Machine Learning Toolbox and by using the examples you can assure to generate models which are compatible with the MeLOn functionalities.</p>
<h2><a class="anchor" id="ffnet-python"></a>
Python</h2>
<h3><a class="anchor" id="ffnet-python-requirements"></a>
Requirements</h3>
<ul>
<li>Python (&gt;=3.6)</li>
<li>tensorflow (&gt;=1.14.0)</li>
<li>tensorflow-model-optimization (&gt;=0.50)</li>
<li>scikit-learn (&gt;=0.23.2)</li>
<li>numpy (&gt;=1.19.4)</li>
<li>matplotlib (&gt;=3.3.3)</li>
</ul>
<h3><a class="anchor" id="ffnet-python-examples"></a>
Using the example scripts</h3>
<p>The two training script included provide you with the following options:</p><ul>
<li>Train a simple dense network</li>
<li>Train a network and perform pruning on its layers to create sparser ones. This can boost the performance of your optimization when you are using the model in your MAiNGO problem formulation later.</li>
</ul>
<p>To use the scripts on your data you have to provide it in a .csv file where each row contains a data point with the first columns containing the values of the input and the following columns containing the ones of the output.</p>
<p>Example: </p><div class="fragment"><div class="line"><span class="preprocessor">#input1,input2,ouput1</span></div>
<div class="line">-3,-3,6.6713e-05</div>
<div class="line">-2.8776,-3,0.0001249</div>
<div class="line">-2.7551,-3,0.00022533</div>
<div class="line">-2.6327,-3,0.00039126</div>
<div class="line">-2.5102,-3,0.0006529</div>
<div class="line">...</div>
</div><!-- fragment --><p>Further, you have to set the file path to your csv and the variables containing your in- and output dimensions in the script file.</p>
<p>Example: </p><div class="fragment"><div class="line">...</div>
<div class="line">filename_data = <span class="stringliteral">&quot;./data.csv&quot;</span></div>
<div class="line">input_dim = 2</div>
<div class="line">output_dim = 1</div>
<div class="line">...</div>
</div><!-- fragment --><p>The variables containing the values of training parameters and basic network structure can be found under the section <code>SET PARAMETERS</code> within the training script. You are free to set the according to your requirements. Please notice the restriction for activation functions in the next section.</p>
<p>The scripts will generate an xml file containing the network data which you have to provide to MeLOn in your C++ program.</p>
<h3><a class="anchor" id="ffnet-python-own-script"></a>
Writing your own script</h3>
<p>You are also free to write your own script. As the C++ part of MeLOn only is compatible with a subset of the features contained in keras there are a few restrictions you have to keep in mind when writing your training script:</p>
<ul>
<li><b>Model</b>: The network has to be a <a href="https://keras.io/api/models/sequential/">keras sequential model</a>.</li>
<li><p class="startli"><b>Scaling</b>: For scaling the in- and output values you have to use the following functions from <code>utils.py</code>:</p><ul>
<li><code>scale</code> for input variables. This function implements a <a href="https://en.wikipedia.org/wiki/Feature_scaling#Rescaling_(min-max_normalization)">min-max normalization</a> to the range [-1,1].</li>
<li><code>normalize</code> for output variables. This function implements a <a href="https://en.wikipedia.org/wiki/Feature_scaling#Standardization_(Z-score_Normalization)">standardization</a> .</li>
</ul>
<p class="startli">You can also choose not to use scaling on either of these.</p>
</li>
<li><b>Layers</b>: The C++ part of MeLOn only supports dense layers. But this doesn't mean that you can only use <a href="https://keras.io/api/layers/core_layers/dense/">keras dense layers</a> in your training. You are free to use layers that only influence the training (e.g. <a href="https://keras.io/api/layers/regularization_layers/dropout/">dropout layers</a>) or to use layer modifiers like <a href="https://www.tensorflow.org/model_optimization/api_docs/python/tfmot/sparsity/keras">pruning layers</a> that can be <a href="https://www.tensorflow.org/model_optimization/api_docs/python/tfmot/sparsity/keras/strip_pruning">removed</a> after training.</li>
<li><b>Activation functions</b>: You can use the following activation functions with their default parameters:<ul>
<li>linear</li>
<li>tanh</li>
<li>relu</li>
<li>relu6</li>
</ul>
</li>
<li><b>Output</b>: To generate the xml file used by the C++ part of MeLOn you have to use the <code>save_model_to_xml</code> function from <code>utils.py</code></li>
</ul>
<h2><a class="anchor" id="ffnet-matlab"></a>
Matlab</h2>
<p>The training script gives you an example of how to train a feedforward neural network in Matlab using the <code>feedforwardnet</code> implementation from the Deep Learning Toolbox. In the example, the training data is generated in the script, but you can also load the data using your preferred method and then use it for training by calling the <code>configuration</code> function for your network. To save the trained network you have to use the <code>sNetwork2CSV</code> function which is located in <code>feedforward neural network\training\matlab\Write ANN to files\sNetwork2CSV.m</code>.</p>
<p>Restrictions for training with Matlab:</p><ul>
<li><b>Activation-/Transferfunction</b>: You can use the following activation functions:<ul>
<li><code>purelin</code></li>
<li><code>tansig</code></li>
</ul>
</li>
</ul>
<h1><a class="anchor" id="ffnet-usage"></a>
Usage</h1>
<p>To include the trained network in your MAiNGO problem formulation you can use the MeLOn C++ interface. An example of how to include a feed forward neural network in your optimization can be found in the MAiNGO folder.</p>
<h2><a class="anchor" id="ffnet-usage-constructors"></a>
Constructors</h2>
<ol type="1">
<li><a class="el" href="classmelon_1_1_feed_forward_net.html#a40d5999e0803420f02e2285aee4d7f19" title="Constructor for creating object with no model loaded.">melon::FeedForwardNet&lt;T&gt;::FeedForwardNet()</a></li>
<li>melon::FeedForwardNet&lt;T&gt;::FeedForwardNet(std::string modelName, MODEL_FILE_TYPE fileType)</li>
<li>melon::FeedForwardNet&lt;T&gt;::FeedForwardNet(std::string modelPath, std::string modelName, MODEL_FILE_TYPE fileType)</li>
<li>melon::FeedForwardNet&lt;T&gt;::FeedForwardNet(std::shared_ptr&lt;AnnData&gt; modelData)</li>
</ol>
<h2><a class="anchor" id="ffnet-usage-prediction"></a>
Prediction</h2>
<ol type="1">
<li><a class="el" href="classmelon_1_1_feed_forward_net.html#aee07aaae68255e370ba1e82c01229cdd" title="Calculates the prediction of the feed forward net for a given point in reduced space mode (only value...">melon::FeedForwardNet&lt;T&gt;::calculate_prediction_reduced_space(const std::vector&lt;T&gt; input)</a></li>
<li><a class="el" href="classmelon_1_1_feed_forward_net.html#a1bbcf42c9cb486f063d8a47722c7a209" title="Calculates the prediction of the feed forward net for a given point in full space mode (values for al...">melon::FeedForwardNet&lt;T&gt;::calculate_prediction_full_space(const std::vector&lt;T&gt; input, const std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints)</a></li>
</ol>
<h2><a class="anchor" id="ffnet-usage-internal-variables"></a>
Internal variables</h2>
<ol type="1">
<li><a class="el" href="classmelon_1_1_feed_forward_net.html#a47ce1749d5969289495ad8a84e438c70" title="Get the number of internal network variables.">melon::FeedForwardNet&lt;T&gt;::get_number_of_full_space_variables()</a></li>
<li><a class="el" href="classmelon_1_1_feed_forward_net.html#a9a6336300c3e798cb58832019e701bc4" title="Returns the number and the names of the internal variables of the network.">melon::FeedForwardNet&lt;T&gt;::get_full_space_variables(unsigned int&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds)</a></li>
</ol>
<h2><a class="anchor" id="ffnet-usage-settings"></a>
Settings</h2>
<ol type="1">
<li>melon::FeedForwardNet&lt;T&gt;::set_tanh_formulation(const TANH_REFORMULATION&amp; reformulation) </li>
</ol>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="index.html">MeLOn - Machine Learning models for Optimization</a></li><li class="navelem"><a class="el" href="models.html">Models</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
